package org.spectrim.hlsvd_; 

public class NativeC 
{
	
    private final int len = 6;
    private final String[] nat_pars;
    // private ReadWriteMRSFiles readwritefiles;
	
    static 
    {
	//System.loadLibrary("libblas");
    	//System.loadLibrary("liblapack");
        
        // System.setProperty( "java.library.path", "C:\\Users\\johan\\Documents\\development\\java\\Netbeans\\spectrIm-QMRS\\spectrIm\\");
        System.loadLibrary( "libgcc_s_seh-1" );
        System.loadLibrary( "libgfortran-4" );
        System.loadLibrary( "libhlsvd" );
        System.loadLibrary( "libwinpthread-1" );
    	System.loadLibrary( "callfortran_hlsvd" );
	System.loadLibrary( "libhlsvd" );
    }
    
    public native String[] callNativeC( String signal_name,
                                        int ndp, double step, double larmor,
                                        String[] str_str, String[] str_int, String[] str_dbl);

    public native double[] getSignal();
    
    public NativeC( String[] pars ) 
    {
	System.out.println("Hello in object of class NativeC");
	nat_pars = new String[pars.length];
		
	for ( int i = 0; i < pars.length; i++ ) 
        {
            nat_pars[i] = pars[i];
	}
		
        for( int i = 0; i < pars.length; i++ ) 
        {
            System.out.println("nat_pars[" + i + "] = " + nat_pars[i]); 
        }

        String signal_name = nat_pars[0];
        int ndp =  Integer.parseInt(pars[1]);
        double step = Double.parseDouble(pars[2]);
        double larmor = Double.parseDouble(pars[3]);

        String[] str_str = new String[len];
        String[] str_int = new String[len];
        String[] str_dbl = new String[len];

        for( int i = 0; i < len; i++ ) 
        {
            str_str[i] = "0";
            str_int[i] = "0";
            str_dbl[i] = "0";
        }

        str_str[0] = pars[4];
        str_str[5] = pars[5];

        str_int[0] = pars[6];
        str_int[1] = pars[7];
        str_int[2] = pars[8];
        str_int[3] = pars[9];

        str_dbl[0] = pars[10];
        str_dbl[1] = pars[11];

        String[] str_return = callNativeC( signal_name, ndp, step, larmor,
                                           str_str, str_int, str_dbl );
        
        String str_return1 = str_return[0];
        System.out.println( str_return1 );

    }
    
    /**
     * Main necessary for testing purposes.
     * @param args 
     */
    public static void main( String args[] ) 
    {
        NativeC myNativeC = new NativeC( args );
    }
    
}
