/*
 * File: $Id: PolygonEvent.java,v 1.1.1.1 2006/04/19 09:38:47 hans Exp $
 * History
 * Date: 31.01.2003  Authors: Martin Buerki / Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */
package org.spectrim.imagegraphicobjects;

import java.util.EventObject;


public class PolygonEvent extends EventObject 
{
    
    // event type constants
    public final static int POLYGON_CHANGED = 1;
    public final static int POLYGON_SELECT = 2;
    public final static int POLYGON_DRAG = 3;
    public final static int POLYGON_CUT_EVENT = 4;
    
    public final static int RECTANGLE_CHANGED = 1;
    public final static int RECTANGLE_SELECT = 2;
    public final static int RECTANGLE_DRAG = 3;

    public Object polygon;
    int type;

    public PolygonEvent( Object source, int eventType, Object P ) 
    {
	super( source );
	type = eventType;
	polygon = P;
    }
    
    // For proper serialization
    private static final long serialVersionUID = 9982128799676883L;
}
