/*
 * File: $Id: PolygonListener.java,v 1.1.1.1 2006/04/19 09:38:47 hans Exp $
 * History
 * Date: 31.01.2003  Authors: Martin Buerki / Hans Slotboom  
 *
 * Changes:
 *
 * Copyright (C) 2003 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */

package org.spectrim.imagegraphicobjects;

import java.util.EventListener;


public interface PolygonListener extends EventListener 
{

    public void polygonChanged( PolygonEvent e );
    
    public void polygonSelect( PolygonEvent e );

    public void polygonDrag( PolygonEvent e );

    public void polygonRemoved( PolygonEvent e );
    
}
