/**
 * File: $Id: MRIPathologyComboBox.java,v 1.1.1.1 2006/04/19 09:38:48 hans Exp $
 * History
 * Date: 15.10.2004, 3:23 PM  Authors: Hans Slotboom
 *
 * Changes:
 *
 * Copyright (C) 2003 -2004 by
 * 
 * Inselspital - Department of Neuroradiology
 * CH 3010 Bern Switzerland
 */
 
package org.spectrim.patientdatabase;

import javax.swing.JComboBox;

/**
 *
 * @author  hans
 */
public class MRIPathologyComboBox extends JComboBox
{
    
    /** 
     * Creates a new instance of MRIPathologyComboBox 
     */
    public MRIPathologyComboBox( ) 
    {
        addItem( "Normal" );
        addItem( "Inflamation" );
        addItem( "Infarction" );
        addItem( "Degenerative" );
        addItem( "Tumor" );
        addItem( "Metabolic desease" );
        addItem( "Genetic defective" );
        addItem( "? Normal tissue ?" );
        addItem( "? Inflamation ?" );
        addItem( "? Degenerative ?" );
        addItem( "? Tumor ?" );
        addItem( "? Metabolic desease ?" );
        addItem( "? Genetic defective ?" );
        addItem( "Unknown" );
    }
    
    // Attributes
    public static String  m_normalTissue = "Normal tissue";
    public static String  m_inflamation = "Inflamation";
    public static String  m_infarction = "Infarction";
    public static String  m_degenerative ="Degenerative";
    public static String  m_tumor = "Tumor";
    public static String  m_metabolicDesease = "Metabolic desease";
    public static String  m_geneticDefect = "Genetic defect";
    public static String  m_questionableNormalTissue = "? Normal tissue ?";
    public static String  m_questionInflamation = "? Inflamation ?";
    public static String  m_questionDegenerative = "? Degenerative ?";
    public static String  m_questionTumor = "? Tumor ?";
    public static String  m_questionMetabolicDesease = "? Metabolic desease ?";
    public static String  m_questionGeneticDefect = "? Genetic defective ?";
    public static String  m_unknown = "Unknown";
    
    // For proper serialization
    private static final long serialVersionUID = 9982232191289213L;
    
}
