/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.tdfdfit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.KeyStroke;

/**
 * 
 * Class to set export of CSV typed MRS(I) data export.
 * 
 * @author johan
 */
public class ExportMRSDataToCSVFileOptionFrame extends javax.swing.JFrame {

    private boolean m_complexConjugateBeforeExporting;

    /**
     * Creates new form ExportMRSDataToCSVFileOptionFrame.
     */
    public ExportMRSDataToCSVFileOptionFrame( ) 
    {
        initComponents( );
        setVisible( true );

        setDefaultCloseOperation( DISPOSE_ON_CLOSE );
        getRootPane( ).setDefaultButton( m_exportToCSVjButton );
            
            
            Action exportAndExit = new AbstractAction( ) 
            {
                @Override
                public void actionPerformed( ActionEvent e ) 
                {
                    m_complexConjugateBeforeExporting = false;
                    notifyActionListeners( NOTIFY_USER_WANTS_CSV_EXPORT_ID, this );
                }
            };
            
            Action exitNoLoad = new AbstractAction( ) 
            {
                @Override
                public void actionPerformed( ActionEvent e ) 
                {
                   dispose( );
                }
            };
            
            getRootPane( ).getInputMap( ).put( KeyStroke.getKeyStroke( "ENTER" ),
                                               "exportAndExit");
            getRootPane( ).getActionMap( ).put( "loadAndExit",
                                                 exportAndExit );
            
            getRootPane( ).getInputMap( ).put( KeyStroke.getKeyStroke( "ESCAPE" ),
                                               "Exit without loading" );
            getRootPane( ).getActionMap( ).put( "Exit without loading",
                                                 exitNoLoad );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        m_firstTDIndexPointjTextField = new javax.swing.JTextField();
        m_lastTDIndexPointjTextField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        m_firstFDIndexPointjTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        m_lastFDIndexPointjTextField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        m_includeFDAbsortionInCSVCheckBox = new javax.swing.JCheckBox();
        m_includeFDDispersionInCSVCheckBox = new javax.swing.JCheckBox();
        m_includeTDAbsortionInCSVCheckBox = new javax.swing.JCheckBox();
        m_includeTDDispersionInCSVCheckBox = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        m_quitWithoutExportjButton = new javax.swing.JButton();
        m_exportToCSVjButton = new javax.swing.JButton();
        m_complexConjugateAndExportToCSVjButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Export MRS-signals to comma separated value file");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Signal boundaries to include in export"));

        m_firstTDIndexPointjTextField.setText("0");

        m_lastTDIndexPointjTextField.setText("1023");
        m_lastTDIndexPointjTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_lastTDIndexPointjTextFieldActionPerformed(evt);
            }
        });

        jLabel1.setText("First index point TD");

        jLabel2.setText("Last index point TD");

        jLabel3.setText("First index point FD");

        m_firstFDIndexPointjTextField.setText("0");

        jLabel4.setText("Last index point FD");

        m_lastFDIndexPointjTextField.setText("1023");
        m_lastFDIndexPointjTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_lastFDIndexPointjTextFieldActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4))
                .addGap(127, 127, 127)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(m_lastFDIndexPointjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(m_firstFDIndexPointjTextField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(m_firstTDIndexPointjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(m_lastTDIndexPointjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_firstTDIndexPointjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_lastTDIndexPointjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_firstFDIndexPointjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(m_lastFDIndexPointjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Export signal types"));

        m_includeFDAbsortionInCSVCheckBox.setSelected(true);
        m_includeFDAbsortionInCSVCheckBox.setText("Export FD absorption");

        m_includeFDDispersionInCSVCheckBox.setSelected(true);
        m_includeFDDispersionInCSVCheckBox.setText("Export FD dispersion");

        m_includeTDAbsortionInCSVCheckBox.setSelected(true);
        m_includeTDAbsortionInCSVCheckBox.setText("Export TD absorption");

        m_includeTDDispersionInCSVCheckBox.setSelected(true);
        m_includeTDDispersionInCSVCheckBox.setText("Export TD dispersion");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_includeFDAbsortionInCSVCheckBox)
                .addGap(18, 18, 18)
                .addComponent(m_includeFDDispersionInCSVCheckBox)
                .addGap(18, 18, 18)
                .addComponent(m_includeTDAbsortionInCSVCheckBox)
                .addGap(18, 18, 18)
                .addComponent(m_includeTDDispersionInCSVCheckBox)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_includeFDAbsortionInCSVCheckBox)
                    .addComponent(m_includeFDDispersionInCSVCheckBox)
                    .addComponent(m_includeTDAbsortionInCSVCheckBox)
                    .addComponent(m_includeTDDispersionInCSVCheckBox))
                .addContainerGap())
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Options"));

        m_quitWithoutExportjButton.setText("Quit without export");
        m_quitWithoutExportjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_quitWithoutExportjButtonActionPerformed(evt);
            }
        });

        m_exportToCSVjButton.setText("Export to csv ...");
        m_exportToCSVjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_exportToCSVjButtonActionPerformed(evt);
            }
        });

        m_complexConjugateAndExportToCSVjButton1.setText("Complex conjugate and Export to csv ...");
        m_complexConjugateAndExportToCSVjButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_complexConjugateAndExportToCSVjButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(m_quitWithoutExportjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 142, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(m_complexConjugateAndExportToCSVjButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(m_exportToCSVjButton, javax.swing.GroupLayout.PREFERRED_SIZE, 142, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(m_quitWithoutExportjButton)
                    .addComponent(m_exportToCSVjButton)
                    .addComponent(m_complexConjugateAndExportToCSVjButton1))
                .addGap(0, 22, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void m_exportToCSVjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_exportToCSVjButtonActionPerformed
        m_complexConjugateBeforeExporting = false;
        notifyActionListeners( NOTIFY_USER_WANTS_CSV_EXPORT_ID, this );
        dispose( );
    }//GEN-LAST:event_m_exportToCSVjButtonActionPerformed

    private void m_quitWithoutExportjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_quitWithoutExportjButtonActionPerformed
        dispose( );
    }//GEN-LAST:event_m_quitWithoutExportjButtonActionPerformed

    private void m_complexConjugateAndExportToCSVjButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_complexConjugateAndExportToCSVjButton1ActionPerformed
        m_complexConjugateBeforeExporting = true;
        notifyActionListeners( NOTIFY_USER_WANTS_COMPLEX_CONJUGATE_AND_CSV_EXPORT_ID, this );
    }//GEN-LAST:event_m_complexConjugateAndExportToCSVjButton1ActionPerformed

    private void m_lastTDIndexPointjTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_lastTDIndexPointjTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_lastTDIndexPointjTextFieldActionPerformed

    private void m_lastFDIndexPointjTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_lastFDIndexPointjTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_m_lastFDIndexPointjTextFieldActionPerformed
   
    public boolean getDoComplexConjugationBeforeExport( )
    {
        return m_complexConjugateBeforeExporting;
    }    
    
    
      /**
     * Adds an ActionListener to the list of action listeners who are notified
     * when something happens with the SpinBox.
     * @param e
     */
    public void addActionListener( ActionListener e )
    {
	m_listeners.add( e );
    }
    
    /** 
     * Notification of registered listeners.
     */
    private void notifyActionListeners( int eventType, Object obj )
    {
        Iterator it = m_listeners.iterator( );
        while( it.hasNext( ) )
        {
            if ( obj != null )
            {
                ( ( ActionListener )it.next( ) ).actionPerformed( new ActionEvent( obj, eventType, "" ) );
            }
        }
    }
    
    
     // Listeners to textfield changes
    private final LinkedList<ActionListener> m_listeners = new LinkedList<>( );
    public final static int     NOTIFY_USER_WANTS_CSV_EXPORT_ID   = 0;
    public final static int     NOTIFY_USER_WANTS_COMPLEX_CONJUGATE_AND_CSV_EXPORT_ID = 1;
    public final static String  NOTIFY_USER_WANTS_CSV_EXPORT_CMD  = "NOTIFY_USER_WANTS_CSV_EXPORT_CMD";
    public final static String  NOTIFY_USER_WANTS_COMPLEX_CONJUGATE_AND_CSV_EXPORT_CMD  = "NOTIFY_USER_WANTS_COMPLEX_CONJUGATE_AND_CSV_EXPORT_ID";
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ExportMRSDataToCSVFileOptionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ExportMRSDataToCSVFileOptionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ExportMRSDataToCSVFileOptionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ExportMRSDataToCSVFileOptionFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ExportMRSDataToCSVFileOptionFrame().setVisible(true);
            }
        });
    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JButton m_complexConjugateAndExportToCSVjButton1;
    private javax.swing.JButton m_exportToCSVjButton;
    private javax.swing.JTextField m_firstFDIndexPointjTextField;
    private javax.swing.JTextField m_firstTDIndexPointjTextField;
    private javax.swing.JCheckBox m_includeFDAbsortionInCSVCheckBox;
    private javax.swing.JCheckBox m_includeFDDispersionInCSVCheckBox;
    private javax.swing.JCheckBox m_includeTDAbsortionInCSVCheckBox;
    private javax.swing.JCheckBox m_includeTDDispersionInCSVCheckBox;
    private javax.swing.JTextField m_lastFDIndexPointjTextField;
    private javax.swing.JTextField m_lastTDIndexPointjTextField;
    private javax.swing.JButton m_quitWithoutExportjButton;
    // End of variables declaration//GEN-END:variables

    public int getTDFirstIndexPoint( ) 
    {
        return new Integer( m_firstTDIndexPointjTextField.getText( ) );
    }
    
    public int getTDLastIndexPoint( ) 
    {
        return new Integer( m_lastTDIndexPointjTextField.getText( ) );
    }

    public int getFDFirstIndexPoint( ) 
    {
        return new Integer( m_firstFDIndexPointjTextField.getText( ) );
    }

    public int getFDLastIndexPoint( ) 
    {
       return new Integer( m_lastFDIndexPointjTextField.getText( ) );
    }

    public boolean includeWriteTDAbs( ) 
    {
        return m_includeTDAbsortionInCSVCheckBox.isSelected( );
    }

    public boolean includeWriteTDDisp( ) 
    {
        return m_includeTDDispersionInCSVCheckBox.isSelected( );
    }

    public boolean includeWriteFDAbs( ) 
    {
        return m_includeFDAbsortionInCSVCheckBox.isSelected( );
    }

    public boolean includeWriteFDDisp( ) 
    {
        return m_includeFDDispersionInCSVCheckBox.isSelected( );
    }
    
}
