/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.spectrim.utilities;

import javax.swing.JMenu;
import javax.swing.MenuElement;

/**
 *
 * @author Giezi
 */
public class StayOpenMenuRadioButtonItem extends JMenu {
    private boolean isSelected = false;
    private String text;
    private StayOpenRadioMenuGroup grp;

    public StayOpenMenuRadioButtonItem() {
        this.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                mouseClickedHere();
            }
        });
    }
    
    private void mouseClickedHere()
    {
        grp.buttonTriggered(this);
    }
    
    private void changeState()
    {
        if(!isSelected)
            text = super.getText();
        isSelected = ! isSelected;
        if(isSelected)
        {
            super.setText("\u25C6 "+text);
        }
        else
            super.setText(text);
    }
    
    public boolean isSelectionActive()
    {
        return isSelected;
    }
    
    public void setSelectionActive(boolean bool)
    {
        if(bool != isSelected)
            changeState();
    }
    
    public void setMenuGrp(StayOpenRadioMenuGroup grp)
    {
        this.grp = grp;
    }
}
