/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.spectrim.dicom;

/**
 *
 * @author slotboom
 */
public class DicomNode
{
    /**
     * Default constructor
     */
    public DicomNode( )
    {

    }

    /**
     *
     * Constructs a new Dicom node
     *
     * @param aetitle
     * @param IP_sent_to_number
     * @param dicomListenPortNumber
     */
    public DicomNode( String aetitle, String IP_number, String dicomListenPortNumber )
    {
        m_aetitle = aetitle;
        m_IP_number = IP_number;
        m_dicomListenPortNumber = dicomListenPortNumber;
    }

    /**
     * Sets the AETitle string
     * @param aetitle
     */
    public void setAETitle( String aetitle )
    {
        m_aetitle = aetitle;
    }

    /**
     * Set the IP-address of the node
     * @param IPString IP_sent_to_number_sent_to_number
     */
    public void setIPNumber( String IP_number )
    {
        m_IP_number = IP_number;
    }

    /**
     * Set the port number to application listens to
     * @param dicomListenPortNumber
     */
    public void setPortNumber( String dicomListenPortNumber )
    {
        m_dicomListenPortNumber = dicomListenPortNumber;
    }

    /**
     * Returns the AETitle string
     */
    public String getAETitle( String aetitle )
    {
        return m_aetitle;
    }

    /**
     * Returns the IP-address of the node
     */
    public String getIPNumber( String IP_number )
    {
        return m_IP_number;
    }

    /**
     * Returns the port number to application listens to
     */
    public String getPortNumber( String dicomListenPortNumber )
    {
        return m_dicomListenPortNumber;
    }
    
    String m_aetitle = null;
    String m_IP_number = null;
    String m_dicomListenPortNumber = null;
}
